(**
   This is a module on termination.
@author Naoki Nishida
@since 2014/06/27
*)
  
open Ctrs;;
open Dp;;
  
(**
   This is an original weight function for function symbols.
*)
let weight f =
  begin
    match f with
      ("bot",None) -> 100
    | _ -> 1
  end;;
    
(**
   This is an indentity weight function.
*)
let id _ = 1;;
    
(**
   This validates termination of a given TRS.
*)
let is_SN spec =
  (List.for_all (is_size_decreasing weight) spec.rules)
||
  let dps = dpairs spec in
  begin
    match dps with
      [] -> true
    | _ -> 
	(
	(List.for_all (is_size_decreasing_eq weight) spec.rules
	   && List.for_all (is_size_decreasing weight) dps)
      || (Graph.union_SCC (mk_edg spec dps) = [])
	  )
  end;;
    
